%define debug_package %{nil}
%define upstream_version %(echo 4.13.0 | tr '~' '-')

Name:    xen-hvm-stubdom-legacy
Version: 4.13.0
Release: 1%{?dist}
Epoch:   2001
Summary: Legacy stubdom files for Xen

License: GPLv2+ and LGPLv2+ and BSD
URL:     http://xen.org/

Source0: xen-%{upstream_version}.tar.gz
Source3: config

# used by stubdoms
Source10: lwip-1.3.0.tar.gz
Source11: newlib-1.16.0.tar.gz
Source12: zlib-1.2.3.tar.gz
Source13: pciutils-2.2.9.tar.bz2
Source14: grub-0.97.tar.gz
Source15: gmp-4.3.2.tar.bz2
Source16: polarssl-1.1.4-gpl.tgz
Source18: tpm_emulator-0.7.4.tar.gz

# Qubes components for stubdom
Source33: gui-agent-xen-hvm-stubdom-5f57a59.tar.gz
Source34: core-vchan-xen-42d07fb.tar.gz
Source35: stubdom-dhcp-3db1240.tar.gz
Source36: gui-common-c611481.tar.gz

Patch600: patch-xen-gcc10-fixes.patch

Patch610: patch-stubdom-gmp-compile-fix.patch
Patch615: patch-hvmpt01-minios-exprom-size.patch
Patch616: patch-hvmpt02-disable-msix-caps.patch
Patch617: patch-hvmpt03-passthrough-log.patch
Patch618: patch-hvmpt04-minios-nomask-bar-addrs.patch
Patch619: patch-hvmpt05-hide-pio-bars.patch
Patch620: patch-hvmpt06-fix-msix.patch
Patch621: patch-libxc-fix-xc_gntshr_munmap-semantic.patch
Patch622: patch-minios-ignore-close-0.patch
Patch624: patch-qemu-docs-utf8.patch
Patch625: patch-minios-remove-net-device-instead-of-preparing-for-re.patch
Patch627: patch-qemu-keyboard-leds.patch

# vchan for stubdom:
Patch801: patch-0100-minios-enhance-xenstore-available-for-stubdoms.patch
Patch803: patch-0102-libvchan-remove-unnecessary-includes.patch
Patch804: patch-0103-minios-implement-gntalloc-interface.patch
Patch805: patch-0104-libxc-implement-gntshr-for-minios.patch
Patch806: patch-0105-stubdom-make-libvchan-available-in-stubdom.patch

Patch1002: patch-xen-no-downloads.patch
Patch1004: patch-xen-stubdom-qubes-gui.patch
Patch1005: patch-stubdom-lwip-fix-for-dhcp.patch

BuildRequires: gcc
BuildRequires: bison
BuildRequires: flex
BuildRequires: autoconf
BuildRequires: automake
BuildRequires: gettext
BuildRequires: glibc-devel
BuildRequires: gnutls-devel
BuildRequires: openssl-devel
BuildRequires: python2-devel
BuildRequires: ncurses-devel gtk2-devel libaio-devel nettle-devel
BuildRequires: pciutils-devel
BuildRequires: libuuid-devel
BuildRequires: acpica-tools
BuildRequires: bzip2-devel xz-devel
BuildRequires: yajl-devel
BuildRequires: cmake
BuildRequires: edk2-ovmf
BuildRequires: dev86

# so that x86_64 builds pick up glibc32 correctly
BuildRequires: /usr/include/gnu/stubs-32.h

Provides: xen-hvm = %{epoch}:%{version}-%{release}
Obsoletes: xen-hvm < 2001:4.13.0-0.1

%description
Legacy stubdom files for Xen


%prep
%autosetup -p1 -n xen-%{upstream_version}

# stubdom sources
cp -v %{SOURCE10} %{SOURCE11} %{SOURCE12} %{SOURCE13} %{SOURCE14} stubdom
cp -v %{SOURCE15} %{SOURCE16} %{SOURCE18} stubdom

# qubes specific parts of stubdom
tar xf %{SOURCE33}
mkdir tools/qubes-gui/
cp -a gui-agent-xen-hvm-stubdom/* tools/qubes-gui/

tar xf %{SOURCE36}
cp -a gui-common/include/qubes-gui*.h tools/qubes-gui/include/
make -C tools/qubes-gui clean

tar xf %{SOURCE34}
cp -a core-vchan-xen/vchan tools/
make -C tools/vchan -f Makefile.stubdom clean
sed -e 's/ioemu-qemu-xen/qemu-xen-traditional/g' tools/qubes-gui/gui-agent-qemu/qemu-glue.patch | patch -p1

tar xf %{SOURCE35}
cp -a stubdom-dhcp/* tools/qemu-xen-traditional/
patch -d tools/qemu-xen-traditional -p4 < stubdom-dhcp/lwip-dhcp-qemu-glue.patch


%build
export XEN_VENDORVERSION="-%{release}"
export EXTRA_CFLAGS_XEN_TOOLS="$RPM_OPT_FLAGS"
export EXTRA_CFLAGS_QEMU_TRADITIONAL="$RPM_OPT_FLAGS"
export EXTRA_CFLAGS_QEMU_XEN="$RPM_OPT_FLAGS"
export PYTHON="/usr/bin/python2"
export KCONFIG_CONFIG=%{SOURCE3}
export XEN_CONFIG_EXPERT=y
export PATH="/usr/bin:$PATH"

cp -f %{SOURCE3} xen/.config

autoreconf
./configure \
    --prefix=%{_prefix} \
    --libdir=%{_libdir} \
    --libexecdir=%{_libexecdir} \
    --disable-vtpm-stubdom \
    --disable-vtpmmgr-stubdom \
    --disable-seabios \
    --disable-xen \
    --disable-docs \
    --disable-largefile \
    --disable-githttp \
    --disable-monitors\
    --disable-ocamltools \
    --disable-xsmpolicy \
    --disable-ovmf \
    --disable-blktap2 \
    --disable-rombios \
    --disable-ipxe \
    --disable-systemd \
    --disable-9pfs

export RPM_OPT_FLAGS_RED=`echo $RPM_OPT_FLAGS | sed -e 's/-m64//g' -e 's/--param=ssp-buffer-size=4//g' -e's/-fstack-protector-strong//'`
export EXTRA_CFLAGS_XEN_TOOLS="$RPM_OPT_FLAGS_RED"

# tools
make %{?_smp_mflags} prefix=/usr tools

# stubdom
make mini-os-dir
make -C stubdom build

# pv-grub
export EXTRA_CFLAGS_XEN_TOOLS="$RPM_OPT_FLAGS_RED"
XEN_TARGET_ARCH=x86_32 make -C stubdom pv-grub

%install
export XEN_VENDORVERSION="-%{release}"
export EXTRA_CFLAGS_XEN_TOOLS="$RPM_OPT_FLAGS"
export EXTRA_CFLAGS_QEMU_TRADITIONAL="$RPM_OPT_FLAGS"
export EXTRA_CFLAGS_QEMU_XEN="$RPM_OPT_FLAGS"
export PATH="/usr/bin:$PATH"
export KCONFIG_CONFIG=%{SOURCE3}
export XEN_CONFIG_EXPERT=y

rm -rf %{buildroot}
mkdir -p %{buildroot}
cp -prlP dist/install/* %{buildroot}
make DESTDIR=%{buildroot} prefix=/usr install-stubdom

# remove unwanted
rm -rf %{buildroot}/etc \
    %{buildroot}/usr/include \
    %{buildroot}/usr/bin \
    %{buildroot}/usr/lib \
    %{buildroot}/usr/lib64 \
    %{buildroot}/usr/sbin \
    %{buildroot}/usr/share \
    %{buildroot}/usr/lib/debug \
    %{buildroot}/%{_libexecdir}/bin \
    %{buildroot}/%{_libexecdir}/xen/bin \
    %{buildroot}/%{_libexecdir}/xen/boot/hvmloader \
    %{buildroot}/%{_libexecdir}/xen/boot/xen-shim \
    %{buildroot}/%{_libexecdir}/qemu-bridge-helper

# stubdom: newlib
rm -rf %{buildroot}/usr/*-xen-elf

%clean
rm -rf %{buildroot}

%files
%defattr(-,root,root)
%dir %{_libexecdir}/xen/boot
%{_libexecdir}/xen/boot/ioemu-stubdom.gz
%{_libexecdir}/xen/boot/xenstore-stubdom.gz
%{_libexecdir}/xen/boot/pv-grub*.gz

%changelog
* Tue Apr 21 2020 Qubes OS Team <qubes-devel@googlegroups.com>
- For complete changelog see: https://github.com/QubesOS/qubes-vmm-xen-stubdom-legacy

* Tue Apr 21 2020 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - 3db1240
- version 4.13.0-1

* Tue Apr 07 2020 Frédéric Pierret (fepitre) <frederic.pierret@qubes-os.org> - 9ccd23c
- Update to xen-4.13.0

* Sun Jan 05 2020 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - 66a2914
- version 4.12.1-3

* Sat Jan 04 2020 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - 1f05ffa
- travis: switch R4.1 dom0 to fc31

* Sat Jan 04 2020 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - a707c7e
- rpm: obsolete old package for clean update

* Fri Dec 20 2019 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - 053c2c8
- Add BR: gcc

* Sat Nov 23 2019 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - d387ad5
- rpm: drop BR: xen-devel

* Sat Oct 19 2019 Frédéric Pierret (fepitre) <frederic.pierret@qubes-os.org> - 78690eb
- travis: switch to bionic

* Wed Oct 09 2019 Frédéric Pierret (fepitre) <frederic.pierret@qubes-os.org> - 7a95c01
- Initial commit from qubes-vmm-xen

